
scheme_weights.test<-0
schemes.test <- function()
{
  local map=HmapMask.fromSimplexNoise(1, 32, 3, FloatRamp.fadeInOut(0, 1, 0, 0.2, 0.8), 0.5)
  local minmax=map.calcMinMax()
  print("range: "+minmax[0]+" .. "+minmax[1]+"\n")

  add_fast_noise(0, 40, ColorRamp(@(t) lerpcolor(0x88ff0000, 0xff228811, t)), GT_ROCK, 255, 0.5)
  // add_simplex_noise(0, 50, 0, 2, 15, 0.5)
  // add_voronoi_hills(8, 0, 20, 1)
  // gen_voronoi_faults(8, 0, 20, 0.05, 4, 3, 8)

  local ramp=ColorRamp(@(t) 0x88ff0000)

  for (local n=5; n; --n)
  {
    local a=frnd()*2*PI
    gen_fault(hmrnd(), hmrnd(), cos(a), sin(a),
      rndf(1, 2)*10, rndf(0.4, 0.6), ramp, GT_ROCK, 255)
  }

  apply_height_mask(null, @(h) h<25 ? 25*2-h:h)

  chem_layers_by_height(irnd()%5)

  common_erosion(90<<10, { Kq=0.1, Kr=0.9, Kd=0.1 })

  // randomize_rnd_seed()

  recolor_chem_layers()

  // add_water_by_height(10, 0)

  // recolor_land4(0x999999, 0x884444, 0x668844, 0x114488)
  // recolor_land3(0x999999, 0x884444, 0x668844)
  // recolor_land3(0x999999, 0x886611, 0x884444)

  // gen_crater(0, 0, rndf(5, 20), rndf(0.5, 1))

  // for (local n=40; n; --n)
  //   place_house(hmrnd(), hmrnd(), 0)

  // for (local n=5; n; --n) add_water_source([hmrnd() 0 hmrnd() 1], 3, 5)
}


scheme_weights.test2<-0
schemes.test2 <- function()
{
  add_fast_noise(0, rndf(1, 2), null, GT_ROCK, 255, 0.5)

  GorgesMod().beforeErosion()
  // chem_layers_by_height(0)
  // recolor_chem_layers()
}
